





function [ c ceq ]= GLOBAL_CONST_GPU( x,Dmin,Kmax )
% constraints function for global optimization

global gpuStruct;

ceq = [];  % no equality constraints

N = size(x,1) /3 ;
path = reshape(x,N,3);

path_PARAMS = compute_linear_params( path );


% % CURVATURE CONSTRAINT ( K = d||T||/dS )
% dS = sqrt( sum( abs( path(2:end,:) - path(1:end-1,:) ).^2,2 ) );
% 
% T = path(2:end,:) - path(1:end-1,:);  % tangent vector
% Tnorm = sqrt( sum( abs(T).^2,2 ) );
% T = T ./ repmat(Tnorm,[1 3]);  % normalize (unit vector)
% 
% K = T(2:end,:) - T(1:end-1,:);
% K = K ./ repmat(dS(1:end-1),[1 3]);  % K = dT/dS
% Knorm_SQ = sum( abs(K).^2,2 );
% 
% Knorm_CONST = Knorm_SQ  -  Kmax^2;


% DISTANCE CONSTRAINT

gpuStruct.ALPHAS(:) = path_PARAMS.alphas';
gpuStruct.BETAS(:) = path_PARAMS.betas';

gpuStruct.DIST_CONST = feval( gpuStruct.GLOBAL_CONST , ...
                                  gpuStruct.DIST_CONST, ...
                                  gpuStruct.ALPHAS , gpuStruct.BETAS, ...
                                  gpuStruct.FOR_LOOP_LIST , gpuStruct.npairs );

Dist_CONST = Dmin^2  -   gather( gpuStruct.DIST_CONST.^2 );


% c = [  Dist_CONST ; Knorm_CONST ];
c = [  Dist_CONST ];














