
clear;

fname = select_file('*.mat','./','SELECT CHAIN MAT FILE TO DUMP AS HFSS SCRIPT');
load(fname);

fname_script = sprintf('%s.vbs',fname(1:end-4));

file = fopen(fname_script,'w');

fprintf(file,'Dim oAnsoftApp\n');
fprintf(file,'Dim oDesktop\n');
fprintf(file,'Dim oProject\n');
fprintf(file,'Dim oDesign\n');
fprintf(file,'Dim oEditor\n');
fprintf(file,'Dim oModule\n');
fprintf(file,'Set oAnsoftApp = CreateObject("Ansoft.ElectronicsDesktop")\n');
fprintf(file,'Set oDesktop = oAnsoftApp.GetAppDesktop()\n');
fprintf(file,'oDesktop.RestoreWindow\n');
fprintf(file,'Set oProject = oDesktop.SetActiveProject("Project1")\n');
fprintf(file,'Set oDesign = oProject.SetActiveDesign("HFSSDesign1")\n');
fprintf(file,'Set oEditor = oDesign.SetActiveEditor("3D Modeler")\n');

fprintf(file,'oEditor.CreatePolyline Array("NAME:PolylineParameters", "IsPolylineCovered:=", true, "IsPolylineClosed:=", false, Array("NAME:PolylinePoints", _ \n');

N = size(chain,1);

for ii = 1:N
    if ii<N       
        fprintf(file,'\tArray("NAME:PLPoint", "X:=", "%fmm", "Y:=", "%fmm", "Z:=", "%fmm"), _\n',chain(ii,1),chain(ii,2),chain(ii,3));
    else
        fprintf(file,'\tArray("NAME:PLPoint", "X:=", "%fmm", "Y:=", "%fmm", "Z:=", "%fmm")), _\n',chain(ii,1),chain(ii,2),chain(ii,3));
    end
end

fprintf(file,'Array("NAME:PolylineSegments", _\n');

for ii = 1:N-1
    
    if ii == (N-1)
        fprintf(file,'\tArray("NAME:PLSegment", "SegmentType:=", "Line", "StartIndex:=", %d, "NoOfPoints:=", 2)), _\n',ii-1);
    else
        fprintf(file,'\tArray("NAME:PLSegment", "SegmentType:=", "Line", "StartIndex:=", %d, "NoOfPoints:=", 2), _\n',ii-1);
    end
end

fprintf(file,'\tArray("NAME:PolylineXSection", "XSectionType:=", "None", "XSectionOrient:=", "Auto", "XSectionWidth:=", "0mm", "XSectionTopWidth:=", "0mm", "XSectionHeight:=",  _\n');
fprintf(file,'\t\t"0mm", "XSectionNumSegments:=", "0", "XSectionBendType:=", "Corner")), Array("NAME:Attributes", "Name:=", "Polyline2", "Flags:=", "", "Color:=", "(132 132 193)", _\n');
fprintf(file,'\t\t"Transparency:=", 0, "PartCoordinateSystem:=", "Global", "UDMId:=", "", "MaterialValue:=", "" & Chr(34) & "vacuum" & Chr(34) & "", "SolveInside:=", true)\n');

fclose(file);






